Scriptname CARIM_MaintenanceScript extends ReferenceAlias

Actor Property PlayerRef auto
Perk Property CARIM_Perk_Control auto
GlobalVariable Property CARIM_DebuffAiming auto
GlobalVariable Property CARIM_DebuffCasting auto
GlobalVariable Property CARIM_DebuffReloading auto

String sFileName = "../../../Casting Aiming Reloading Impede Movement"

Event OnInit()
	RegisterForSingleUpdate(1.0)
EndEvent

Event OnPlayerLoadGame()
	Maintenance()
EndEvent

Event OnUpdate()
	Maintenance()
EndEvent

Function Maintenance()
	CARIM_Perk_Control.SetNthEntryValue(0, 1, (ClampValues((JsonUtil.GetFloatValue(sFileName, "aiming movement speed debuff %", 95.0) / 100.0))))
	CARIM_Perk_Control.SetNthEntryValue(1, 1, (ClampValues((JsonUtil.GetFloatValue(sFileName, "casting movement speed debuff %", 95.0) / 100.0))))
	CARIM_Perk_Control.SetNthEntryValue(2, 1, (ClampValues((JsonUtil.GetFloatValue(sFileName, "reloading movement speed debuff %", 95.0) / 100.0))))
	if JsonUtil.GetIntValue(sFileName, "apply to player", 0) == 0
		PlayerRef.RemovePerk(CARIM_Perk_Control)
	else
		if !PlayerRef.HasPerk(CARIM_Perk_Control)
			PlayerRef.AddPerk(CARIM_Perk_Control)
		endif
	endif
	SetToggle(CARIM_DebuffAiming, "apply to aiming")
	SetToggle(CARIM_DebuffCasting, "apply to casting")
	SetToggle(CARIM_DebuffReloading, "apply to reloading")
EndFunction

Function SetToggle(GlobalVariable Option, String KeyName)
	if JsonUtil.GetIntValue(sFileName, KeyName, 1) == 0
		Option.SetValueInt(0)
	else
		Option.SetValueInt(1)
	endif
EndFunction

Float Function ClampValues(Float f)
	if f > 0.95
		Return 0.95
	elseif f < 0.0
		Return 0.0
	else
		Return f
	endif
EndFunction